
Redmine - Patch #37135

Reduce extra queries in ProjectQuery.default

2022-05-18 17:26 - Dmitry Makurin 

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Marius BĂLTEANU % Done: 0%

Category: Performance Estimated time: 0.00 hour

Target version: 5.0.2   

Description

Same as #36503 but for ProjectQuery.

Currently redmine tries to select default_project_query even if settings are empty.

diff --git a/app/models/project_query.rb b/app/models/project_query.rb

index 002437aeb..8c6643c7b 100644

--- a/app/models/project_query.rb

+++ b/app/models/project_query.rb

@@ -39,10 +39,13 @@ class ProjectQuery < Query

   def self.default(project: nil, user: User.current)

     query = nil

-    if user&.logged?

-      query = find_by_id user.pref.default_project_query

+    if user&.logged? && (query_id = user.pref.default_project_query).present?

+      query = find_by(id: query_id)

     end

-    query || find_by_id(Setting.default_project_query)

+    if query.nil? && (query_id = Setting.default_project_query).present?

+      query = find_by(id: query_id)

+    end

+    query

   end

   def initialize(attributes=nil, *args)

Related issues:

Related to Redmine - Feature #35795: Settings for global and user default cus... Closed

Copied from Redmine - Patch #36503: Reduce extra queries in IssueQuery.default Closed

Associated revisions

Revision 21614 - 2022-05-28 11:54 - Marius BĂLTEANU

Reduce extra queries in ProjectQuery.default (#37135).

Patch by Dmitry Makurin.

Revision 21622 - 2022-05-28 20:29 - Marius BĂLTEANU

Merged r21614 to 5.0-stable (#37135).

History

#1 - 2022-05-18 17:26 - Dmitry Makurin 

- Copied from Patch #36503: Reduce extra queries in IssueQuery.default added

#2 - 2022-05-25 08:24 - Go MAEDA

- Description updated

#3 - 2022-05-25 08:27 - Go MAEDA

- Assignee deleted (Go MAEDA)
- Target version set to 5.0.2

Setting the target version to 5.0.2.

#4 - 2022-05-25 08:27 - Go MAEDA

- Related to Feature #35795: Settings for global and user default custom ProjectQuery added

#5 - 2022-05-28 11:56 - Marius BĂLTEANU

- Status changed from New to Resolved

- Assignee set to Marius BĂLTEANU

Patch committed, thanks!

#6 - 2022-05-28 20:29 - Marius BĂLTEANU

- Status changed from Resolved to Closed

Powered by TCPDF (www.tcpdf.org)

2025-05-02 2/2

http://www.tcpdf.org

